package loan.origination.result;

import com.openrules.core.DecisionModel;
import com.openrules.core.Goal;

import loan.origination.*;

public class ResultLauncher {

	DecisionModel resultModel;
	Goal resultGoal;

	public ResultLauncher() {
		resultModel = new LoanOriginationResult();
		resultGoal = resultModel.createGoal();
	}

	public static void main(String[] args) {

		long startTime = System.currentTimeMillis();
		
		ResultLauncher launcher = new ResultLauncher();

		Applicant[] applicants = applicantsArray.get();
		RequestedProduct[] requestedProducts = productsArray.get();
		Application[] applications = applicationsArray.get();
		BureauData[] bureauData =  bureauDataArray.get();

		for (int i = 0; i < applications.length; i++) {
			System.out.println("\n" + applications[i].toString());
			launcher.execute(applications[i], applicants[i], requestedProducts[i],bureauData[i]);
			System.out.println(
					"\n *** TEST-" + (i + 1) + " Loan Origination Result: " + applications[i].getLoanOriginationResult() + " ***");
		}

		long endTime = System.currentTimeMillis();
		System.out.println("Total Elapsed time: " + (endTime - startTime + 1) + " ms");

	}

	public void execute(Application application, Applicant applicant, RequestedProduct requestedProduct, BureauData bureauData) {
		resultGoal.use("Application", application);
		resultGoal.use("Applicant", applicant);
		resultGoal.use("RequestedProduct", requestedProduct);
		resultGoal.use("BureauData", bureauData);
		resultGoal.execute();
	}
}
